<template>
    <div>
        <main>
            <section class="section section-shaped section-lg">
                <div class="shape shape-style-1 bg-gradient-default">
                    <span></span>
                    <span></span>
                    <span></span>
                    <span></span>
                    <span></span>
                    <span></span>
                    <span></span>
                    <span></span>
                </div>
                <div class="container pt-lg-md">
                    <div class="row justify-content-center">
                        <div class="col-lg-5">
                            <div class="card bg-secondary shadow border-0">
                                <div class="card-body px-lg-5 py-lg-5">
                                    <div class="text-center text-muted mb-4">
                                        <h1 class="text-center mb-4">Sign in</h1>
                                    </div>
                                    <form role="form">
                                        <div class="form-group mb-3">
                                            <div class="input-group input-group-alternative">
                                                <div class="input-group-prepend">
                                                    <span class="input-group-text"><i class="ni ni-email-83"></i></span>
                                                </div>
                                                <input class="form-control" v-model="form.email.val" name="email" placeholder="Email" type="email">
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <div class="input-group input-group-alternative">
                                                <div class="input-group-prepend">
                                                    <span class="input-group-text"><i class="ni ni-lock-circle-open"></i></span>
                                                </div>
                                                <input class="form-control" v-model="form.password.val" name="password" placeholder="Password" type="password">
                                            </div>
                                        </div>
                                        <div class="custom-control custom-control-alternative custom-checkbox">
                                            <input class="custom-control-input" id=" customCheckLogin" type="checkbox">
                                            <label class="custom-control-label" for=" customCheckLogin"><span>Remember me</span></label>
                                        </div>
                                        <div class="text-center">
                                            <button v-if="!form.loading" @click="login" id="loginSubmit" type="button" class="btn btn-primary my-4">Sign in</button>
                                            <fingerprint-spinner
                                                    v-else
                                                    :animation-duration="1500"
                                                    :size="64"
                                                    color="#5e72e4"
                                                    style="width: 100%"
                                            />
                                        </div>
                                    </form>
                                    <div class="alert alert-danger alert-dismissible fade show" v-if="form.sent && !form.success" role="alert">
                                        <span class="alert-inner--text">Something went wrong !</span>
                                    </div>
                                </div>
                            </div>
                            <div class="row mt-3">
                                <div class="col-6">
                                    <a href="#" class="text-light"><small>Forgot password?</small></a>
                                </div>
                                <div class="col-6 text-right">
                                    <nuxt-link class="text-light" to="/authentication/register"><small>Create new account</small></nuxt-link>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </section>
        </main>
    </div>
</template>
<script>
    import Vue from 'vue'
    import {FingerprintSpinner} from 'epic-spinners'
    export default {
        middleware: 'auth',
        auth: 'guest',
        components: {
            FingerprintSpinner
        },
        data() {
            return {
                form: {
                    loading: false,
                    email: {
                        val: '',
                        msg: '',
                        valid: true
                    },
                    password: {
                        val: '',
                        msg: '',
                        valid: true
                    },
                    success: false,
                    sent: false
                }
            }
        },
        mounted () {
            console.log(process.env.BACKEND_API)
        },
        methods: {
            async login() {
                let form = this.form
                form.loading = true
                try {
                    await this.$auth.loginWith('local', {
                        data: {
                            email: form.email.val,
                            password: form.password.val
                        }
                    })
                    form.email.valid = true
                    form.password.valid = true
                    form.success = true;
                    form.sent = true;
                    form.loading = false
                    Vue.notify({
                        group: 'foo',
                        type: 'success',
                        title: 'Sign in',
                        text: 'Successfully signed in!'
                    })
                } catch (e) {
                    Vue.notify({
                        group: 'foo',
                        type: 'error',
                        title: 'Error',
                        text: 'Something went wrong!'
                    })
                    form.success = false;
                    form.sent = true;
                    this.error = e.response
                    form.loading = false
                }
            },
        }
    }
</script>
<style>
    body {
        height: 100%;
    }
    .section-lg {
        height: 100vh;
    }
</style>